﻿Imports EF6Model.Models.Enums
Imports EF6Model.Models.Interfaces
Imports System.Runtime.CompilerServices


Namespace EF6Model.RichModels

  Public Class Ninja
	  Implements IObjectWithState
  Public Shared Function CreateIndependent(ByVal name As String, ByVal servedinOniwaban As Boolean) As Ninja
	Dim ninja = New Ninja(name, servedinOniwaban)
	ninja.State = ObjectStates.Added
	Return ninja
  End Function
  Public Shared Function CreateBoundToClan(ByVal name As String, ByVal servedinOniwaban As Boolean, ByVal clanId As Integer) As Ninja
	Dim ninja = New Ninja(name, servedinOniwaban)
	ninja.ClanId = clanId
	ninja.State = ObjectStates.Added
	Return ninja
  End Function
	Private Sub New()
	End Sub
  Public Sub New(ByVal name As String, ByVal servedinOniwaban As Boolean)
            EquipmentOwned = New List(Of NinjaEquipment)
            Me.Name = name
	Me.ServedInOniwaban = servedinOniwaban
  End Sub

  Private privateId As Integer
        Public Property Id As Integer
            Get
                Return privateId
            End Get
            Private Set(ByVal value As Integer)
                privateId = value
            End Set
        End Property
        Private privateName As String
        Public Property Name As String
            Get
                Return privateName
            End Get
            Private Set(ByVal value As String)
                privateName = value
            End Set
        End Property
        Private privateServedInOniwaban As Boolean
        Public Property ServedInOniwaban As Boolean
            Get
                Return privateServedInOniwaban
            End Get
            Private Set(ByVal value As Boolean)
                privateServedInOniwaban = value
            End Set
        End Property
        Private privateClan As Clan
        Public Property Clan As Clan
            Get
                Return privateClan
            End Get
            Private Set(ByVal value As Clan)
                privateClan = value
            End Set
        End Property
        Private privateClanId As Integer
        Public Property ClanId As Integer
            Get
                Return privateClanId
            End Get
            Private Set(ByVal value As Integer)
                privateClanId = value
            End Set
        End Property
        Private privateEquipmentOwned As List(Of NinjaEquipment)
        Public Property EquipmentOwned As List(Of NinjaEquipment)
            Get
                Return privateEquipmentOwned
            End Get
            Private Set(ByVal value As List(Of NinjaEquipment))
                privateEquipmentOwned = value
            End Set
        End Property
        Public Property State As ObjectStates Implements IObjectWithState.State

        Public Sub ModifyOniwabanStatus(ByVal served As Boolean)
	ServedInOniwaban = served
	SetModifedIfNotAdded()
  End Sub
  Private Sub SetModifedIfNotAdded()
	If State <> ObjectStates.Added Then
	  State = ObjectStates.Modified
	End If
  End Sub
  Public Sub SpecifyClan(ByVal clan As Clan)
	Clan = clan
	ClanId = clan.Id
	SetModifedIfNotAdded()
  End Sub
  Public Sub SpecifyClan(ByVal id As Integer)
	ClanId = id
	SetModifedIfNotAdded()
  End Sub
  Public Sub AddEquipmentToNinja(ByVal equipmentName As String)
	EquipmentOwned.Add(NinjaEquipment.Create(Id, equipmentName))
  End Sub
	Public Sub TransferEquipmentFromAnotherNinja(ByVal equipment As NinjaEquipment)
	  EquipmentOwned.Add(equipment.ChangeOwner(Id))
	End Sub
	Public Sub EquipmentNoLongerExists(ByVal equipment As NinjaEquipment)
	  equipment.State = ObjectStates.Deleted
	End Sub


  End Class
End Namespace