﻿Imports System.Data.Entity
Imports System.Data.Entity.Infrastructure
Imports System.Net
Imports System.Web.Http
Imports System.Web.Http.Description
Imports EF6Model

Imports EF6Model.RichModels

Namespace EF6WebAPI.Controllers
  Public Class NinjasController
	  Inherits ApiController
		Private db As New NinjaContext()


		Public Function GetNinjas() As IQueryable(Of Ninja)
			Return db.Ninjas
		End Function


		<ResponseType(GetType(Ninja))>
		Public Function GetNinja(ByVal id As Integer) As IHttpActionResult
			Dim ninja As Ninja = db.Ninjas.Find(id)
			If ninja Is Nothing Then
				Return NotFound()
			End If

			Return Ok(ninja)
		End Function


		<ResponseType(GetType(void))>
		Public Function PutNinja(ByVal id As Integer, ByVal ninja As Ninja) As IHttpActionResult
			If Not ModelState.IsValid Then
				Return BadRequest(ModelState)
			End If

			If id <> ninja.Id Then
				Return BadRequest()
			End If

			db.Entry(ninja).State = EntityState.Modified

			Try
				db.SaveChanges()
			Catch e1 As DbUpdateConcurrencyException
				If Not NinjaExists(id) Then
					Return NotFound()
				Else
					Throw
				End If
			End Try

			Return StatusCode(HttpStatusCode.NoContent)
		End Function


		<ResponseType(GetType(Ninja))>
		Public Function PostNinja(ByVal ninja As Ninja) As IHttpActionResult
			If Not ModelState.IsValid Then
				Return BadRequest(ModelState)
			End If

			db.Ninjas.Add(ninja)
			db.SaveChanges()

			Return CreatedAtRoute("DefaultApi", New With {Key .id = ninja.Id}, ninja)
		End Function

		' DELETE: api/Ninjas/5
		<ResponseType(GetType(Ninja))>
		Public Function DeleteNinja(ByVal id As Integer) As IHttpActionResult
			Dim ninja As Ninja = db.Ninjas.Find(id)
			If ninja Is Nothing Then
				Return NotFound()
			End If

			db.Ninjas.Remove(ninja)
			db.SaveChanges()

			Return Ok(ninja)
		End Function

		Protected Overrides Overloads Sub Dispose(ByVal disposing As Boolean)
			If disposing Then
				db.Dispose()
			End If
			MyBase.Dispose(disposing)
		End Sub

		Private Function NinjaExists(ByVal id As Integer) As Boolean
			Return db.Ninjas.Count(Function(e) e.Id = id) > 0
		End Function
  End Class
End Namespace